#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2300one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 2300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2300one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one23004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


 
                         
# -------------------------------------------------------------------------------------------------
# 2300
# -------------------------------------------------------------------------------------------------                                          
shot2one23004xi = {
                  1:'0x0y2299z',
                  2:'0x1522y1723z',
                  3:'0x69y2298z',
                  4:'1017x1170y1698z',
                  5:'104x2057y1022z',
                  6:'1058x1406y1479z',
                  7:'1058x1635y1223z',
                  8:'1065x1103y1713z',
                  9:'1080x1741y1043z',
                  10:'109x117y2294z',
                  11:'10x275y2283z',
                  12:'1109x1034y1728z',
                  13:'1121x1337y1497z',
                  14:'1135x1567y1242z',
                  15:'1148x963y1743z',
                  16:'1164x1674y1063z',
                  17:'1179x1266y1514z',
                  18:'1183x891y1758z',
                  19:'118x140y2292z',
                  20:'1207x1496y1261z',
                  21:'1213x818y1773z',
                  22:'1233x1192y1532z',
                  23:'1243x1602y1084z',
                  24:'124x164y2290z',
                  25:'1275x1421y1280z',
                  26:'1282x1116y1549z',
                  27:'128x190y2288z',
                  28:'129x242y2283z',
                  29:'130x216y2286z',
                  30:'1318x1526y1104z',
                  31:'131x281y2379z',
                  32:'1326x1037y1566z',
                  33:'132x1907y1277z',
                  34:'1339x1343y1299z',
                  35:'1366x957y1582z',
                  36:'1389x1447y1124z',
                  37:'1398x1263y1318z',
                  38:'13x18y2299z',
                  39:'1452x1179y1337z',
                  40:'1454x1365y1144z',
                  41:'1501x1094y1356z',
                  42:'1515x1279y1164z',
                  43:'151x1736y1500z',
                  44:'155x1479y1753z',
                  45:'1570x1191y1184z',
                  46:'179x2127y854z',
                  47:'211x2039y1043z',
                  48:'22x251y2286z',
                  49:'230x1452y1768z',
                  50:'230x1885y1296z',
                  51:'240x1711y1517z',
                  52:'24x38y2299z',
                  53:'289x2106y876z',
                  54:'2x23y2299z',
                  55:'2x46y2299z',
                  56:'302x1420y1783z',
                  57:'315x2014y1063z',
                  58:'326x1681y1534z',
                  59:'326x1858y1315z',
                  60:'32x1924y1258z',
                  61:'32x227y2288z',
                  62:'33x60y2298z',
                  63:'371x1385y1797z',
                  64:'397x2080y897z',
                  65:'40x202y2290z',
                  66:'40x82y2298z',
                  67:'410x1647y1551z',
                  68:'418x1984y1083z',
                  69:'420x1825y1334z',
                  70:'437x1347y1811z',
                  71:'45x105y2297z',
                  72:'45x178y2292z',
                  73:'47x129y2295z',
                  74:'47x153y2294z',
                  75:'491x1608y1568z',
                  76:'501x1305y1825z',
                  77:'503x2047y918z',
                  78:'511x1788y1353z',
                  79:'519x1949y1104z',
                  80:'561x1260y1839z',
                  81:'569x1565y1585z',
                  82:'600x1745y1371z',
                  83:'607x2009y939z',
                  84:'617x1909y1124z',
                  85:'618x1213y1853z',
                  86:'61x1757y1482z',
                  87:'644x1519y1602z',
                  88:'671x1163y1867z',
                  89:'67x2142y833z',
                  90:'685x1699y1390z',
                  91:'708x1966y960z',
                  92:'712x1863y1144z',
                  93:'716x1468y1618z',
                  94:'721x1110y1880z',
                  95:'72x56y2298z',
                  96:'767x1056y1893z',
                  97:'767x1648y1408z',
                  98:'784x1414y1634z',
                  99:'78x1503y1738z',
                  100:'803x1813y1164z',
                  101:'806x1917y981z',
                  102:'809x999y1906z',
                  103:'846x1593y1426z',
                  104:'848x1358y1650z',
                  105:'848x941y1919z',
                  106:'86x75y2297z',
                  107:'882x882y1931z',
                  108:'892x1758y1183z',
                  109:'901x1863y1002z',
                  110:'909x1298y1666z',
                  111:'913x822y1944z',
                  112:'921x1534y1444z',
                  113:'939x760y1956z',
                  114:'962x699y1968z',
                  115:'965x1235y1682z',
                  116:'977x1698y1203z',
                  117:'992x1472y1462z',
                  118:'992x1805y1022z',
                  119:'99x95y2295z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2300one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2300one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2300ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2300ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2300ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2300ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2300ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE23004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one23004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2300ONE4XI - SUCCEEDED TO PUT SHOT2ONE23004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE23004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2300ONE4XI *** FAILED TO PUT SHOT2ONE23004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2300ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one23004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one23004xi</nack2put4xi>" 
            
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
         
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2300ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one23004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE2300ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2300ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2300one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
